package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.ontology.OntologyManager;
import de.uka.ipd.consensus.foundation.schema.Association;
import de.uka.ipd.consensus.foundation.schema.Rating;
import de.uka.ipd.consensus.foundation.schema.User;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class ChangeAssociationRatingAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );
		}

		String associd   = request.getParameter("id");
		String ratingstr = ((DynaActionForm)form).getString("assocrating");
		String comment   = ((DynaActionForm)form).getString("ratingcomment");
		
		double value;
		
		if (this.getRatingManager() != null) {
			value = this.getRatingManager().stringToRatingValue( ratingstr );
		}
		else {
			value = Rating.NEUTRAL;
		}

		OntologyManager om = this.getOntologyManager();
		
		User user = this.getUser(request);

 		Association a = om.getQueryEngine().getAssociationById( user, associd );
		
		Rating r = a.addRating( user, value );

		r.setComment( user, comment );

		this.getLoggingManager().debug("Change rating for " + a + " to " + ratingstr + "/" + value + " (by " + user + ")");

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
